## ros-noetic-grepros 0.5.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.8)
project(grepros)

if($ENV{ROS_VERSION} EQUAL "1")
  find_package(catkin REQUIRED COMPONENTS
    genpy rosbag roslib rospy
  )

  catkin_python_setup()

  if(CATKIN_ENABLE_TESTING)
    find_package(rostest REQUIRED)
    find_package(std_msgs REQUIRED)

    catkin_add_nosetests(test/test_bag_to_console.py)
    catkin_add_nosetests(test/test_bag_to_bag.py)
    catkin_add_nosetests(test/test_bag_to_csv.py)
    catkin_add_nosetests(test/test_bag_to_html.py)
    catkin_add_nosetests(test/test_bag_to_sqlite.py)
    catkin_add_nosetests(test/test_bag_to_sql.py)
    add_rostest(test/test_bag_to_live.launch)
    add_rostest(test/test_live_to_console.launch)
  endif()

  catkin_package(CATKIN_DEPENDS genpy rosbag roslib rospy)

  catkin_install_python(PROGRAMS
                        scripts/${PROJECT_NAME}
                        DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION})
else()
  find_package(ament_cmake REQUIRED)
  find_package(ament_cmake_python REQUIRED)
  find_package(rclpy REQUIRED)
  find_package(rosidl_parser REQUIRED)
  find_package(rosidl_runtime_py REQUIRED)

  find_package(ament_lint_auto REQUIRED)

  if(BUILD_TESTING)
    find_package(ament_cmake_pytest REQUIRED)
    find_package(std_msgs REQUIRED)

    ament_add_pytest_test(test_bag_to_console  test/test_bag_to_console.py)
    ament_add_pytest_test(test_bag_to_bag      test/test_bag_to_bag.py)
    ament_add_pytest_test(test_bag_to_csv      test/test_bag_to_csv.py)
    ament_add_pytest_test(test_bag_to_html     test/test_bag_to_html.py)
    ament_add_pytest_test(test_bag_to_sqlite   test/test_bag_to_sqlite.py)
    ament_add_pytest_test(test_bag_to_sql      test/test_bag_to_sql.py)
    ament_add_pytest_test(test_bag_to_live     test/test_bag_to_live.py)
    ament_add_pytest_test(test_live_to_console test/test_live_to_console.py)
  endif()

  ament_python_install_package(${PROJECT_NAME} PACKAGE_DIR src/${PROJECT_NAME})
  ament_package()
endif()

=== requirements.txt ===
# ROS1 deps not pip-installable: genpy, rosbag, roslib, rospy
# ROS2 deps not pip-installable: builtin_interfaces, rclpy, rosidl_runtime_py
# embag input: embag
# mcap support: mcap, mcap_ros1_support, mcap_ros2_support
# parquet output: pandas, pyarrow
# postgres output: psycopg2
# decompressing archived bags: zstandard
# for generating API documentation: git+https://github.com/Feneric/doxypypy
pyyaml

=== debian/changelog ===
ros-noetic-grepros (0.5.0-1buster) buster; urgency=high

  * add --plugin grepros.plugins.mcap (MCAP input and output)
  * refactor internal bag API
  * fix message type definition parsing yielding duplicate subtypes
  * fix error in example usage text

 -- Erki Suurjaak <erki@lap.ee>  Sat, 29 Oct 2022 21:00:00 -0000

ros-noetic-grepros (0.4.7-1buster) buster; urgency=high

  * fix space leak in caching message metadata

 -- Erki Suurjaak <erki@lap.ee>  Sun, 19 Jun 2022 21:00:00 -0000

ros-noetic-grepros (0.4.6-1buster) buster; urgency=high

  * add forgotten implementation for --every-nth-match
  * fix --every-nth-message
  * fix error on grepping bags where no topic or type name matches given filter

 -- Erki Suurjaak <erki@lap.ee>  Wed, 25 May 2022 21:00:00 -0000

ros-noetic-grepros (0.4.5-1buster) buster; urgency=high

  * fix forcing all numeric array fields to integer lists regardless of type
  * fix error on subscribing to defunct topic

 -- Erki Suurjaak <erki@lap.ee>  Mon, 18 Apr 2022 21:00:00 -0000

ros-noetic-grepros (0.4.4-1buster) buster; urgency=high

  * add support for reading zstd-compressed bagfiles
  * use message type definition from ROS1 live topics instead of locally installed package
  * optimize partial printing of very long array fields
  * optimize CSV output of very long array fields
  * strip leading "./" from printed filename prefix if grepping working directory
  * fix not skipping ROS2 bag if all topics filtered out
  * fix making compatible QoS for ROS2 topic subscriptions
  * fix making unique filename on error in HTML output

 -- Erki Suurjaak <erki@lap.ee>  Tue, 15 Mar 2022 22:00:00 -0000

ros-noetic-grepros (0.4.3-1buster) buster; urgency=high

  * continue subscribing to other live topics even if one causes error
  * continue reading from ROS2 bag even if one message type causes error
  * subscribe to live topics in ROS2 with QoS matching publisher
  * fix not saving publisher QoS profiles in written ROS2 bags
  * fix package build not including submodules (#1)

 -- Erki Suurjaak <erki@lap.ee>  Mon, 28 Feb 2022 22:00:00 -0000

ros-noetic-grepros (0.4.2-1buster) buster; urgency=high

  * add overwrite=true|false to --write options
  * add column-name=rostype:value to --write Parquet options
  * add scripts/generate_msgs.py
  * create message type definition from .idl if .msg file not available in ROS2
  * improve DDS type parsing in ROS2
  * handle ROS2 char and byte int8/uint8 reversal vs ROS1
  * fix assembling message type full definition in ROS2
  * fix processing byte values in ROS2
  * fix processing bounded string types in ROS2
  * fix inserting chars in Postgres
  * fix inserting very large integers in SQLite

 -- Erki Suurjaak <erki@lap.ee>  Tue, 08 Feb 2022 22:00:00 -0000

ros-noetic-grepros (0.4.1-1buster) buster; urgency=high

  * refactor database and SQL sinks onto a common base
  * allow specifying dialect options in Postgres/SQLite output
  * allow overriding table and view names in SQL dialects
  * allow specifying field value adapters in SQL dialects
  * allow specifying structured type mappings in Parquet output like type-uint8[]="list(uint8())"
  * drop meta-table from Postgres output
  * drop default value from --publish-prefix option
  * fix error in parsing subtypes from message definitions
  * fix converting ROS2 temporal messages to seconds/nanoseconds

 -- Erki Suurjaak <erki@lap.ee>  Fri, 07 Jan 2022 22:00:00 -0000

ros-noetic-grepros (0.4.0-1buster) buster; urgency=high

  * add --plugin grepros.plugins.parquet (Parquet output)
  * add --plugin grepros.plugins.sql (SQL schema output)
  * add --plugin grepros.plugins.embag (faster ROS1 bag reader)
  * add --reindex-if-unindexed option
  * add --every-nth-match option
  * add --every-nth-message option
  * add --every-nth-interval option
  * allow multiple write sinks, combine --write-format and --write-option to --write
  * refactor plugins interface
  * populate topics.offered_qos_profiles in ROS2 bag output where possible
  * fix progress bar afterword not updating when grepping multiple bags
  * fix error on empty bag with no messages
  * fix error in Postgres output for NaNs in nested JSON values
  * fix skipping some messages in ROS1 bag for types with identical hashes
  * fix not being able to specify list arguments several times
  * ensure no conflicts from changed message types or identical type hashes
  * add tests

 -- Erki Suurjaak <erki@lap.ee>  Sat, 25 Dec 2021 22:00:00 -0000

ros-noetic-grepros (0.3.5-1buster) buster; urgency=high

  * fix Postgres output not having content

 -- Erki Suurjaak <erki@lap.ee>  Mon, 13 Dec 2021 22:00:00 -0000

ros-noetic-grepros (0.3.4-1buster) buster; urgency=high

  * add --write-option message-yaml=true|false, for SQLite output
  * speed up SQLite output (~4-8x)
  * speed up YAML formatting (~2x)
  * fix no engine name in console texts for Postgres output

 -- Erki Suurjaak <erki@lap.ee>  Mon, 13 Dec 2021 22:00:00 -0000

ros-noetic-grepros (0.3.3-1buster) buster; urgency=high

  * fix errors in Postgres/SQLite output

 -- Erki Suurjaak <erki@lap.ee>  Sun, 12 Dec 2021 22:00:00 -0000

ros-noetic-grepros (0.3.2-1buster) buster; urgency=high

  * rename --write-option commit_interval to commit-interval
  * raise Postgres default commit-interval from 100 to 1000
  * add --write-option commit-interval support to SQLite output
  * add --write-option subtypes=array|all, for Postgres/SQLite output
  * speed up SQLite output (~2x)
  * refactor Postgres/SQLite sinks onto common base class

 -- Erki Suurjaak <erki@lap.ee>  Sat, 11 Dec 2021 22:00:00 -0000

ros-noetic-grepros (0.3.1-1buster) buster; urgency=high

  * add --write-option template=/my/html.template, for HTML output
  * add --write-option commit_interval=NUM, for Postgres output
  * drop --write-format-template
  * fix highlighting subtype arrays

 -- Erki Suurjaak <erki@lap.ee>  Sun, 05 Dec 2021 22:00:00 -0000

ros-noetic-grepros (0.3.0-1buster) buster; urgency=high



=== debian/control ===
Source: ros-noetic-grepros
Section: misc
Priority: optional
Maintainer: Erki Suurjaak <erki@lap.ee>
Build-Depends: debhelper (>= 9.0.0), python3-yaml, ros-noetic-catkin, ros-noetic-genpy, ros-noetic-rosbag, ros-noetic-roslib, ros-noetic-rospy, ros-noetic-rostest <!nocheck>, ros-noetic-std-msgs <!nocheck>
Homepage: http://www.ros.org/wiki/grepros
Standards-Version: 3.9.2

Package: ros-noetic-grepros
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, python3-yaml, ros-noetic-genpy, ros-noetic-rosbag, ros-noetic-roslib, ros-noetic-rospy
Description: grep for ROS bag files and live topics

## ros-noetic-grepros 1.0.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -20,6 +20,8 @@
     catkin_add_nosetests(test/test_bag_to_sql.py)
     add_rostest(test/test_bag_to_live.launch)
     add_rostest(test/test_live_to_console.launch)
+    catkin_add_nosetests(test/test_api.py)
+    catkin_add_nosetests(test/test_library.py)
   endif()
 
   catkin_package(CATKIN_DEPENDS genpy rosbag roslib rospy)
@@ -48,6 +50,8 @@
     ament_add_pytest_test(test_bag_to_sql      test/test_bag_to_sql.py)
     ament_add_pytest_test(test_bag_to_live     test/test_bag_to_live.py)
     ament_add_pytest_test(test_live_to_console test/test_live_to_console.py)
+    ament_add_pytest_test(test_api             test/test_api.py)
+    ament_add_pytest_test(test_library         test/test_library.py)
   endif()
 
   ament_python_install_package(${PROJECT_NAME} PACKAGE_DIR src/${PROJECT_NAME})

=== requirements.txt ===
--- 
+++ 
@@ -7,3 +7,4 @@
 # decompressing archived bags: zstandard
 # for generating API documentation: git+https://github.com/Feneric/doxypypy
 pyyaml
+six

=== debian/changelog ===
ros-noetic-grepros (1.0.0-1focal) focal; urgency=high

  * make grepros conveniently usable as a library
  * add --no-highlight option
  * add --stop-on-error option
  * rename options --print-field and --no-print-field to --emit-field and --no-emit-field
  * support --emit-field --no-emit-field in CSV and Parquet exports
  * handle all numpy types in ROS2 messages, not only ndarrays
  * avoid raising errors for unknown message types in ROS2 bags if not reading those topics
  * fix grepping and emitting specific messages fields only
  * fix not skipping live topics published by grepros itself in ROS2
  * fix embag reader
  * verify output targets being writable on startup
  * provide connection header in writing ROS1 bag if topic has multiple types
  * smooth over rosbag bug of ignoring topic and time filters in format v1.2
  * print ROS1 master URI in verbose mode on connecting to live topics
  * raise error on loading Parquet plugin if libraries unavailable
  * support "postgres://" as auto-detected Postgres target in addition to "postgresql://"
  * use bagfile format as last when auto-detecting output format
  * add MCAP bag interface
  * auto-detect MCAP output by file extension
  * add inputs.AppSource and outputs.AppSink
  * add api.deserialize_message() dict_to_message() make_full_typename() time_message() to_time()
  * rename api.get_message_data() to serialize_message()
  * fix api.message_to_dict() giving invalid names for temporal types in ROS2

 -- Erki Suurjaak <erki@lap.ee>  Tue, 12 Jul 2022 21:00:00 -0000

ros-noetic-grepros (0.6.0-1focal) focal; urgency=high

  * add nesting=array|all to --write Parquet options
  * add idgenerator=callable to --write Parquet options
  * add api.canonical()
  * match bounded array fields to configured output types properly
    in Parquet/Postgres/SQL/SQLite output, like "uint8[10]" for "BYTEA" in Postgres
  * workaround for ROS1 time/duration fields defined as int32 while actually being uint32
  * fix date formatting in HTML output

 -- Erki Suurjaak <erki@lap.ee>  Sun, 26 Mar 2023 21:00:00 -0000

ros-noetic-grepros (0.5.0-1focal) focal; urgency=high

  * add --plugin grepros.plugins.mcap (MCAP input and output)
  * refactor internal bag API
  * fix message type definition parsing yielding duplicate subtypes
  * fix error in example usage text

 -- Erki Suurjaak <erki@lap.ee>  Mon, 17 Oct 2022 21:00:00 -0000

ros-noetic-grepros (0.4.7-1focal) focal; urgency=high

  * fix space leak in caching message metadata

 -- Erki Suurjaak <erki@lap.ee>  Sun, 19 Jun 2022 21:00:00 -0000

ros-noetic-grepros (0.4.6-1focal) focal; urgency=high

  * add forgotten implementation for --every-nth-match
  * fix --every-nth-message
  * fix error on grepping bags where no topic or type name matches given filter

 -- Erki Suurjaak <erki@lap.ee>  Wed, 25 May 2022 21:00:00 -0000

ros-noetic-grepros (0.4.5-1focal) focal; urgency=high

  * fix forcing all numeric array fields to integer lists regardless of type
  * fix error on subscribing to defunct topic

 -- Erki Suurjaak <erki@lap.ee>  Mon, 18 Apr 2022 21:00:00 -0000

ros-noetic-grepros (0.4.4-1focal) focal; urgency=high

  * add support for reading zstd-compressed bagfiles
  * use message type definition from ROS1 live topics instead of locally installed package
  * optimize partial printing of very long array fields
  * optimize CSV output of very long array fields
  * strip leading "./" from printed filename prefix if grepping working directory
  * fix not skipping ROS2 bag if all topics filtered out
  * fix making compatible QoS for ROS2 topic subscriptions
  * fix making unique filename on error in HTML output

 -- Erki Suurjaak <erki@lap.ee>  Tue, 15 Mar 2022 22:00:00 -0000

ros-noetic-grepros (0.4.3-1focal) focal; urgency=high

  * continue subscribing to other live topics even if one causes error
  * continue reading from ROS2 bag even if one message type causes error
  * subscribe to live topics in ROS2 with QoS matching publisher
  * fix not saving publisher QoS profiles in written ROS2 bags
  * fix package build not including submodules (#1)

 -- Erki Suurjaak <erki@lap.ee>  Mon, 28 Feb 2022 22:00:00 -0000

ros-noetic-grepros (0.4.2-1focal) focal; urgency=high

  * add overwrite=true|false to --write options
  * add column-name=rostype:value to --write Parquet options
  * add scripts/generate_msgs.py
  * create message type definition from .idl if .msg file not available in ROS2
  * improve DDS type parsing in ROS2
  * handle ROS2 char and byte int8/uint8 reversal vs ROS1
  * fix assembling message type full definition in ROS2
  * fix processing byte values in ROS2
  * fix processing bounded string types in ROS2
  * fix inserting chars in Postgres
  * fix inserting very large integers in SQLite

 -- Erki Suurjaak <erki@lap.ee>  Tue, 08 Feb 2022 22:00:00 -0000

ros-noetic-grepros (0.4.1-1focal) focal; urgency=high

  * refactor database and SQL sinks onto a common base
  * allow specifying dialect options in Postgres/SQLite output
  * allow overriding table and view names in SQL dialects
  * allow specifying field value adapters in SQL dialects
  * allow specifying structured type mappings in Parquet output like type-uint8[]="list(uint8())"
  * drop meta-table from Postgres output
  * drop default value from --publish-prefix option
  * fix error in parsing subtypes from message definitions
  * fix converting ROS2 temporal messages to seconds/nanoseconds

 -- Erki Suurjaak <erki@lap.ee>  Fri, 07 Jan 2022 22:00:00 -0000

ros-noetic-grepros (0.4.0-1focal) focal; urgency=high

  * add --plugin grepros.plugins.parquet (Parquet output)
  * add --plugin grepros.plugins.sql (SQL schema output)
  * add --plugin grepros.plugins.embag (faster ROS1 bag reader)
  * add --reindex-if-unindexed option
  * add --every-nth-match option
  * add --every-nth-message option
  * add --every-nth-interval option
  * allow multiple write sinks, combine --write-format and --write-option to --write
  * refactor plugins interface


=== debian/control ===
Source: ros-noetic-grepros
Section: misc
Priority: optional
Maintainer: Erki Suurjaak <erki@lap.ee>
Build-Depends: debhelper (>= 9.0.0), python3-six, python3-yaml, ros-noetic-catkin, ros-noetic-genpy, ros-noetic-rosbag, ros-noetic-roslib, ros-noetic-rospy, ros-noetic-rostest <!nocheck>, ros-noetic-std-msgs <!nocheck>
Homepage: http://www.ros.org/wiki/grepros
Standards-Version: 3.9.2

Package: ros-noetic-grepros
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, python3-six, python3-yaml, ros-noetic-genpy, ros-noetic-rosbag, ros-noetic-roslib, ros-noetic-rospy
Description: grep for ROS bag files and live topics: read, filter, export

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/noetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF -DCATKIN_ENABLE_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/noetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/noetic" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-noetic-grepros//opt/ros/noetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_install
